<template>
  <div>
    <div class="while-waiting" v-show="this.productList == []">
      <img src="https://media.giphy.com/media/55mcm80T6alKjcuO5q/giphy.gif" alt="waiting" />
    </div>

    <div>
      <h1>NUESTROS PRODUCTOS</h1>

      <v-col class="d-flex" cols="12" sm="6" md="3">
        <v-select
          v-model="searchedCategory"
          :items="items"
          label="Categorias"
          v-on:change="searchForProductsPerCategory()"
          dense
          placeholder="Categorias"
        ></v-select>
      </v-col>

      <span v-show="showThis">No hay productos disponibles</span>

      <section class="cards-wrapper">
        <div v-for="(product, index) in productList" :key="index">
          <ProductBox
            class="promo-box"
            @go-to-this-product-details="goTOProductDetails"
            :productBoxDetails="product"
          />
        </div>
      </section>
    </div>
  </div>
</template>

<script>
import ProductBox from './ProductBox.vue'

import API from '@/API.js'
export default {
  name: 'ProductList',
  components: {
    ProductBox
  },
  props: {},
  data() {
    return {
      idActualUser: '',
      searchedcategoryrutes: this.$route.params.categoryName,
      searchedProductsNameroute: this.$route.params.name,
      categories: [],
      productList: [],
      searchedCategory: 'null',
      searchedProductsName: 'null',
      items: [],
      showThis: false,
      galeryHasShow: true
    }
  },
  async mounted() {
    this.idActualUser = this.$route.params.idActualUser
    this.searchedCategory = this.searchedcategoryrutes
    this.searchedProductsName = this.searchedProductsNameroute
    await this.loadCategories()
    if (this.searchedProductsName !== undefined) {
      await this.searchProductByName()
    } else if (this.searchedcategoryrutes !== undefined) {
      await this.searchForProductsPerCategory()
      this.searchedcategoryrutes = null
    } else {
      await this.PutResultLoadProductListEnData()
    }

    this.items = this.categories.map(sweetItem => {
      return sweetItem['categoryName']
    })
  },

  watch: {
    '$route.params.name': {
      immediate: true,
      handler: async function() {
        console.log('i am watching nada')
        if (this.$route.params.name !== undefined) {
          this.productList = await API.searchProductByName(
            this.$route.params.name
          )
          console.log('i am done watching ')
        } else {
          this.productList = await API.loadProductList()
        }
      }
    },
    productList: {
      immediate: true,
      handler: function() {
        if (this.productList.length === 0) {
          this.showThis = true
        } else {
          this.showThis = false
        }
      }
    }
  },

  methods: {
    async loadCategories() {
      this.categories = await API.loadCategories()
    },
    async searchProductByName() {
      const searchedWord = this.searchedProductsName
      this.productList = await API.searchProductByName(searchedWord)
    },

    async PutResultLoadProductListEnData() {
      this.productList = await API.loadProductList()
    },

    async PutResultLoadProductDetailsEnData() {
      let searchedCategory = this.searchedCategory
      this.productList = await API.loadProductsDetailsBySearchedCategory(
        searchedCategory
      )
      if (this.productList.categoria === 'false') {
        this.showThis = true
        this.galeryHasShow = false
      }
    },

    async searchForProductsPerCategory() {
      this.showThis = false
      this.galeryHasShow = true
      if (this.searchedCategory === 'All-Categories') {
        await this.PutResultLoadProductListEnData()
      } else {
        await this.PutResultLoadProductDetailsEnData()
      }
    },

    goTOProductDetails(id_product) {
      if (this.idActualUser === undefined) {
        this.$router.push('/product-detail/' + id_product)
      } else {
        this.$router.push(
          '/product-detail/' + this.idActualUser + '/' + id_product
        )
      }
    }
  }
}
</script>

<style scoped>
.cards-wrapper {
  display: grid;
  justify-content: center;
  align-items: center;
  grid-template-columns: 1fr 1fr 1fr 1fr;
  grid-gap: 4rem;
  padding: 4rem;
  margin: 0 auto;
  width: max-content;
}
@media screen and (max-width: 1285px) {
  .cards-wrapper {
    grid-template-columns: 1fr 1fr;
  }
}

@media screen and (max-width: 900px) {
  .cards-wrapper {
    grid-template-columns: 1fr;
  }
  .info {
    justify-content: center;
  }
  .card-grid-space .num {
    /margin-left: 0;
    /text-align: center;
  }
}

@media screen and (max-width: 500px) {
  .cards-wrapper {
    padding: 4rem 2rem;
  }
  .card {
    max-width: calc(100vw - 4rem);
  }
}

@media screen and (max-width: 450px) {
  .info {
    display: block;
    text-align: center;
  }
  .info h1 {
    margin: 0;
  }
}
</style>
